/*
 * FreeWnn is a network-extensible Kana-to-Kanji conversion system.
 * This file is part of FreeWnn.
 *
 * Copyright Kyoto University Research Institute for Mathematical Sciences
 *                 1987, 1988, 1989, 1990, 1991, 1992
 * Copyright OMRON Corporation. 1987, 1988, 1989, 1990, 1991, 1992, 1999
 * Copyright ASTEC, Inc. 1987, 1988, 1989, 1990, 1991, 1992
 * Copyright FreeWnn Project 1999, 2000
 *
 * Maintainer:  FreeWnn Project   <freewnn@tomo.gr.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define WNN_YOMI_SIZE 10
typedef struct wnn_jl_bun WNN_BUN;

struct wnn_jl_bun
{
  int jirilen;                  /* ʸμΩ */
  int dic_no;
  int entry;
  int kangovect;                /* ³٥ȥơ֥ؤΥݥ */
  int hinsi;                    /* ʻ */
  int hindo:16;                 /* () */
  int ref_cnt:4;                /* ʸꥹȤ˻ȤƤ */
  /* BUG FIX signed --> unsigned */
  unsigned int ima:1;           /* Ȥäӥå */
  unsigned int hindo_updated:1; /* ʸ٤ϹƤ */
  unsigned int nobi_top:1;      /* Ф̤ߤԤä򼨤 */
  /* egg ߤ˿Ф̤ߤ򷫤֤Ԥˡ˸κ
     Ȥä ӥåȤ ȤƤϤʤʤ */
  unsigned int dai_top:1;       /* ʸƬ */
  unsigned int dai_end:1;       /* ʸsaigo *//*  nomi */
  unsigned int from_zenkouho:2; /*䤫򤵤줿ʸᤫɤ */
  unsigned int bug:1;           /* BUG FIX Ȥꤢ */
  /* BUG FIX signed --> unsigned */
  int hyoka;
  int daihyoka;
  short yomilen;
  short kanjilen;
  WNN_BUN *down;                /* ȤäӥåȤȤоݤʸ */
  w_char yomi[WNN_YOMI_SIZE];   /* ɤߡ롣ڤʤˤ
                                   ˤĤʤ */
  WNN_BUN *next;                /* Υȥ饯ȤؤΥݥ */
  WNN_BUN *free_next;           /* Υȥ饯ȤؤΥݥ */
};


struct wnn_buf
{
  struct wnn_env *env;          /* Ķ */
  int bun_suu;                  /* ʸ */
  int zenkouho_suu;             /* ο */
  WNN_BUN **bun;                /* ʸؤΥݥ */
  WNN_BUN **down_bnst;          /* ȤäӥåȤȤоݤʸ */

  WNN_BUN **zenkouho;           /* ؤΥݥ */
  int *zenkouho_dai;            /* daibunsetsu zenkouho */
  int zenkouho_dai_suu;         /* daibunsetsu zenkouho suu */

  short c_zenkouho;             /* 桢ܤƤ */
  short zenkouho_daip;
  int zenkouho_bun;             /* äƤʸ */
  int zenkouho_end_bun;         /* (dai)äƤǸʸ */
  int zenkouho_endvect;         /* ä endvect *//* ADD KURI */

  WNN_BUN *free_heap;
  char *heap;                   /* linked list of alloced area */
  int msize_bun;
  int msize_zenkouho;
};

